<?php
// This file is a demo of the TaxControls PHP table distribution.
// Copyright 1997-2020 Caliber Technology LLC.  All rights reserved.
   include_once("taxes.php");
   function getVar($name, $default){
     if (array_key_exists($name, $_REQUEST))
       return $_REQUEST[$name];
     else
       return $default;
   }
   $me = $_SERVER['PHP_SELF'];
   $state = getVar('state', '');
   $alien = getVar('alien', 'off');
   $w4 = getVar('w4', 'off');
   $step2c = getVar('step2c', 'off');
   $line3 = getVar('line3', 0.00);
   $line_4a = getVar('line_4a', 0.00);
   $line_4b = getVar('line_4b', 0.00);
   $earnings = getVar('earnings', 2000.00);
   $ytdearnings = getVar('ytdearnings', 0.00);
   $exemptions = getVar('exemptions', 2);
   $stateexemptions = getVar('stateexemptions', 2);
   $filingstatus = getVar('filingstatus', 0);
   $payperiods = getVar('payperiods', 12);
   $miscellaneous = getVar('miscellaneous', 0);
   $auxiliary = getVar('auxiliary', 0);
   function filingOptions(){
     global $filingstatus;
     $ar = array('Single', 'Head of Household', 'Widow(er)', 'Married', 'Married Filing Separately', 'Married Both Employed');
     $res = '';
     for ($i=0; $i<count($ar); $i++){
      if ($i==$filingstatus)
          $res .= "<option value='$i' selected='true'>$ar[$i]</option>
";
        else
          $res .= "<option value='$i'>$ar[$i]</option>
";
     }
     return $res;
   }
   function PeriodOptions(){
     global $payperiods;
     $ar = array(1=>'Annually', 52=>'Weekly', 26=>'Biweekly', 24=>'Twice/month',12=>'Monthly',4=>'Quarterly');
     $res = '';
     foreach ($ar as $i=>$v){
       if ($i==$payperiods)
          $res .= "<option value='$i' selected='true'>$v</option>
";
        else
          $res .= "<option value='$i'>$v</option>
";
     }
     return $res;
   }
$long_names = array('AL' => 'Alabama', 'AK' => 'Alaska', 
		    'AZ' => 'Arizona', 'AR' => 'Arkansas', 'CA' => 'California', 'CO' => 'Colorado',
		    'CT' => 'Connecticut', 'DE' => 'Delaware', 'FL' => 'Florida',
		    'GA' => 'Georgia', 'HI' => 'Hawaii', 
		    'ID' => 'Idaho', 'IL' => 'Illinois', 'IN' => 'Indiana', 'IA' => 'Iowa',
		    'KS' => 'Kansas', 'KY' => 'Kentucky', 'LA' => 'Louisiana',
		    'ME' => 'Maine', 'MD' => 'Maryland', 'MA' => 'Massachusetts',
		    'MI' => 'Michigan', 'MN' => 'Minnesota', 
		    'MS' => 'Mississippi', 'MO' => 'Missouri', 'MT' => 'Montana', 
		    'NE' => 'Nebraska', 'NV' => 'Nevada', 'NH' => 'New Hampshire',
		    'NJ' => 'New Jersey', 'NM' => 'New Mexico', 'NY' => 'New York',
		    'NC' => 'North Carolina', 'ND' => 'North Dakota', 
		    'OH' => 'Ohio', 'OK' => 'Oklahoma', 'OR' => 'Oregon',
		    'PA' => 'Pennsylvania', 'PR' => 'Puerto Rico', 'RI' => 'Rhode Island',
		    'SC' => 'South Carolina', 'SD' => 'South Dakota', 'TN' => 'Tennessee',
		    'TX' => 'Texas', 'UT' => 'Utah', 'VT' => 'Vermont', 'VA' => 'Virginia',
		    'WA' => 'Washington', 'WV' => 'West Virginia', 'WI' => 'Wisconsin',
		    'WY' => 'Wyoming');
   function StateOptions(){
     global $state,$long_names;
     $res = '';
     foreach ($long_names as $k=>$v){
        if ($k==$state)
          $res .= "<option value='$k' selected='true'>$v</option>
";
        else
          $res .= "<option value='$k'>$v</option>
";
     }
     return $res;
   }
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en-US">
<html>
<head>
<title>PHP demo</title>
<style>
input {text-align: right; }
tr {text-align: right; }
.helptext { font-size: 0.8em; color: #888888; }
#result_table { background-color: #dddddd; }
#result_table caption { color: #800; }
.disabled { color: #eeeeee; }
.enabled { color: #000000; }
</style>
<script type="text/javascript">
var state_details = [];
<?php
 // We use PHP here to write out some javascript code.
 // Here we build up a javascript array "state_details" with instructions for each state
 // This gets referenced by the setInstructions function below any time the state select
 // control gets changed.
 foreach (taxList() as $key => $tax){
   if ($tax->type=="S"){
     if ($tax->miscellaneous_instructions){
        $m = $tax->miscellaneous_instructions;
	$m = addslashes(str_replace("\n", " ", $m));
     } else
        $m = false;
     if ($tax->miscellaneous_tag)
        $mt =  addslashes($tax->miscellaneous_tag);
     else
        $mt = false;
     if ($tax->auxiliary_instructions)
        $a = addslashes($tax->auxiliary_instructions);
     else
        $a = false;
     if ($tax->auxiliary_tag)
        $at = addslashes($tax->auxiliary_tag);
     else
        $at = false;
     if ($tax->state_exemption_instructions)
        $s = addslashes($tax->state_exemption_instructions);
     else
        $s = false;
     if ($tax->stateexemption_tag)
        $st = addslashes($tax->stateexemption_tag);
     else
        $st = false;

     echo "state_details['$key'] = { miscellaneous: '$m', miscellaneous_tag: '$mt',
	     auxiliary: '$a', auxiliary_tag: '$at',
	     state_exemptions: '$s', state_exemptions_tag: '$st' };\n";
   }
 }
?>
// enables some rows if 2020 W-4 is checked:
function toggle(){
	var w4 = document.getElementById("w4").checked;
	enable_row("step_2c", w4);
	enable_row("line3", w4);
	enable_row("line_4a", w4);
	enable_row("line_4b", w4);
	enable_row("exemptions", !w4);
}
function enable_row(id, enabled){
	var elem = document.getElementById(id);
	var row = elem.parentElement.parentElement;
	if (enabled){
		elem.disabled = false;
		row.classList = ["enabled"]
	} else {
		elem.disabled = true;
		row.classList = ["disabled"]
	}
}
// sets the form labels according to the state_details entry for the currently
// selected state:
function setInstructions(){
   var sel = document.getElementById('state');
   var state = sel.value;
   var entry = state_details[sel.value];
   var miscHelp = document.getElementById('miscellaneousHelp').firstChild;
   miscHelp.nodeValue = entry.miscellaneous;
   var auxHelp = document.getElementById('auxiliaryHelp').firstChild;
   auxHelp.nodeValue = entry.auxiliary;
   var stateTag = document.getElementById('state_tag').firstChild;
   if (entry.state_tag){
	   stateTag.nodeValue = entry.state_exemptions_tag + ':';
   } else {
	   stateTag.nodeValue = 'State Exemptions:';
   }
   var miscTag = document.getElementById('misc_tag').firstChild;
   miscTag.nodeValue = entry.miscellaneous_tag + ':';
   var auxTag = document.getElementById('aux_tag').firstChild;
   auxTag.nodeValue = entry.auxiliary_tag + ':';
   var exemptHelp = document.getElementById('exemptionsHelp').firstChild;
   exemptHelp.nodeValue = entry.state_exemptions;
   document.getElementById('misc_row').style.display = entry.miscellaneous ? "table-row" : "none";
   document.getElementById('aux_row').style.display = entry.auxiliary ? "table-row" : "none";
}
// this is how we get the instructions to show up when the page loads initially:
window.addEventListener('load', setInstructions, false);
// set up the Step 2(c) row:
window.addEventListener('load', toggle, false);
</script>
</head>
<body>
<div id="input">
<form action="<?= $me ?>" method="GET">
<table id="earnings_data">
<tr>
    <td>Pay Period:</td>
    <td><select name="payperiods"><?= PeriodOptions() ?></select></td>
</tr>
<tr>
    <td>State:</td>
    <td><select name="state" id="state" onChange="setInstructions();"><?= StateOptions() ?></select></td>
</tr>
<tr>
    <td>Filing Status:</td>
    <td><select name="filingstatus"><?= filingOptions() ?></select></td>
</tr>
<tr>
    <td>Earnings:</td>
    <td><input type="text" name="earnings" value="<?= $earnings ?>" /></td>
</tr>
<tr>
    <td>YTD Earnings:</td>
    <td><input type="text" name="ytdearnings" value="<?= $ytdearnings ?>" /></td>
</tr>
<tr>
    <td>Nonresident Alien?:</td>
    <td><input type="checkbox" name="alien" <?php if ($alien=='on') print 'checked' ?>/></td>
</tr>
<tr>
    <td>2020 W-4?:</td>
    <td><input id="w4" type="checkbox" name="w4" onClick="toggle()" <?php if ($w4=='on') print 'checked' ?>/></td>
</tr>
<tr>
    <td>W-4 Step 2(c) checked?:</td>
    <td><input id="step_2c" type="checkbox" name="step2c" <?php if ($step2c=='on') print 'checked' ?>/></td>
</tr>
<tr>
    <td>W-4 Line 3:</td>
    <td><input id="line3" type="text" name="line3" value="<?= $line3 ?>"/></td>
</tr>
<tr>
    <td>W-4 Line 4a:</td>
    <td><input id="line_4a" type="text" name="line_4a" value="<?= $line_4a ?>"/></td>
</tr>
<tr>
    <td>W-4 Line 4b:</td>
    <td><input id="line_4b" type="text" name="line_4b" value="<?= $line_4b ?>"/></td>
</tr>
<tr><td>Exemptions:</td>
    <td><input id="exemptions" type="text" name="exemptions" value="<?= $exemptions ?>" /></td>
</tr>
<tr><td id="state_tag">State Exemptions:</td>
    <td><input type="text" name="stateexemptions" value="<?= $stateexemptions ?>" /></td>
    <td id="exemptionsHelp" class="helptext" width=400px align="left">&nbsp;</td>
</tr>
<tr id="misc_row">
    <td id="misc_tag">Miscellaneous:</td>
    <td><input type="text" name="miscellaneous" value="<?= $miscellaneous ?>" /></td>
    <td id="miscellaneousHelp" class="helptext" width=400px align="left">&nbsp;</td>
</tr>
<tr id="aux_row">
    <td id="aux_tag">Auxiliary:</td>
    <td><input type="text" name="auxiliary" value="<?= $auxiliary ?>" /></td>
    <td id="auxiliaryHelp" class="helptext" width=400px align="left">&nbsp;</td>
</tr>

<tr>
    <td>&nbsp;</td>
    <td><input type="submit" name="calculate" title="Calculate withholding amounts" value="Calc" /></td>
</tr>
</table>
</form>
</div>
<?php if (getVar('calculate', false)){?>
<div id="results">
<table id="result_table">
<caption align="top">Results:</caption>
<?php
     setlocale(LC_MONETARY, 'en_US');
     $formatter = new NumberFormatter('en_US', NumberFormatter::CURRENCY);
     $paydate = mktime(0, 0, 0, 1, 1, 2019);  // if paydate is 0, compute uses current date
     // If the employee has signed the Federal 2020 W-4, we have several extra inputs (compared to previous
     // years). Note that the new W-4 doesn't use allowances, so we've reused $exemptions to represent the
     // Line 3 amount:
     if ($w4=='on') {
	     $exemptions = $line3;
	     $misc = $line_4a - $line_4b;
	     $aux = ($step2c=='on' ? 1 : 0);
	     $state_exemptions = ($alien=='on' ? -1 : 0);
	     $fit = $formatter->formatCurrency(compute('Federal Income Tax',$earnings,$ytdearnings,$filingstatus,
		     $exemptions,$state_exemptions,$payperiods, $paydate, $misc, $aux), 'USD');
     } else {
	     $misc = 0.0;
	     $aux = ($alien=='on' ? 1 : 0);
	     $fit = $formatter->formatCurrency(compute('FIT',$earnings,$ytdearnings,$filingstatus,
		     $exemptions,$stateexemptions,$payperiods, $paydate, $misc, $aux), 'USD');
     }
     print "<tr><td>Federal:</td><td>$fit</td></tr>\n";
     $ficass = $formatter->formatCurrency(compute('FICA SS',$earnings,$ytdearnings,$filingstatus,
					 $exemptions,$stateexemptions,$payperiods, $paydate), 'USD');
     print "<tr><td>FICA SS:</td><td>$ficass</td></tr>\n";
     $ficamed = $formatter->formatCurrency(compute('FICA Med',$earnings,$ytdearnings,$filingstatus,
					 $exemptions,$stateexemptions,$payperiods, $paydate), 'USD');
     print "<tr><td>FICA Med:</td><td>$ficamed</td></tr>\n";
     $st = "0.00";
     if ($state!=''){
	     // AL, IA, and OR need the federal withholding in Auxiliary!
	     if (in_array($state, ["AL", "IA", "OR"])){
		     $auxiliary = $fit;
	     }
	     $st = $formatter->formatCurrency(compute($state,$earnings,$ytdearnings,$filingstatus,
		     $exemptions,$stateexemptions,$payperiods,
		     $paydate,$miscellaneous, $auxiliary), 'USD');
     }
     print "<tr><td>State ($state):</td><td>$st</td></tr>\n";
   }
?>
</table>
</div>
</body>
</html>
